=== debian/changelog ===
u-boot (2021.01+dfsg-5+rpi1+deb11u1) bullseye-staging; urgency=medium

  [changes brought forward from 2014.10+dfsg1-2+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Fri, 28 Nov 2014 06:00:07 +0000]
  * Don't build versions for various armv7 devices, build rpi version instead.

  [changes introduced in 2021.01+dfsg-4+rpi1 by Peter Michael Green]
  * Don't build powerpc targets for qemu, my attempts to build the nessacery
    cross-compiler in raspbian failed.

 -- Raspbian forward porter <root@raspbian.org>  Sun, 04 May 2025 21:27:20 +0000

u-boot (2021.01+dfsg-5+deb11u1) bullseye-security; urgency=medium

  * Non-maintainer upload by the Debian LTS team.
  * d/patches/CVE-2022-34835.patch: Add patch to fix CVE-2022-34835.
    - Fix an integer signedness error and resultant stack-based buffer overflow
      in the 'i2c md' command that enables the corruption of the return address
      pointer of the do_i2c_md function (closes: #1014529).
  * d/patches/CVE-2022-33967.patch: Add patch to fix CVE-2022-33967.
    - Fix a heap-based buffer overflow vulnerability due to a defect in the
      metadata reading process which may lead to a denial-of-service (DoS)
      condition or arbitrary code execution by loading a specially crafted
      squashfs image.
  * d/patches/CVE-2022-33103.patch: Add patch to fix CVE-2022-33103.
    - Fix an an out-of-bounds write (closes: #1014528).
  * d/patches/CVE-2022-30790.patch: Add patch to fix CVE-2022-30790 and
    CVE-2022-30552.
    - Fix a a Buffer Overflow (closes: #1014470).
  * d/patches/CVE-2022-30767.patch: Add patch to fix CVE-2022-30767.
    - Fix an unbounded memcpy with a failed length check, leading to a buffer
      overflow. This issue exists due to an incorrect fix for CVE-2019-14196
      (closes: #1014471).
  * d/patches/CVE-2022-2347.patch: Add patch to fix CVE-2022-2347.
    - Fix an unchecked length field leading to a heap overflow
      (closes: #1014959).
  * d/patches/CVE-2024-57254.patch: Add patch to fix CVE-2024-57254.
    - Fix an integer overflow in sqfs_inode_size (closes: 1098254).
  * d/patches/CVE-2024-57255.patch: Add patch to fix CVE-2024-57255.
    - Fix an integer overflow in sqfs_resolve_symlink (closes: #1098254).
  * d/patches/CVE-2024-57256.patch: Add patch to fix CVE-2024-57256.
    - Fix an integer overflow in ext4fs_read_symlink (closes: #1098254).
  * d/patches/CVE-2024-57257.patch: Add patch to fix CVE-2024-57257.
    - Fix a stack consumption issue in sqfs_size possible with deep symlink
      nesting (closes: #1098254).
  * d/patches/CVE-2024-57258-1.patch, d/patches/CVE-2024-57258-2.patch,
    d/patches/CVE-2024-57258-3.patch: Add patches to fx CVE-2024-57258.
    - Fix multiple integer overflows (closes: #1098254).
  * d/patches/CVE-2024-57259.patch: Add patch to fix CVE-2024-57259.
    - Fix an off-by-one error resulting in a heap memory corruption in
      sqfs_search_dir (closes: #1098254).

 -- Daniel Leidert <dleidert@debian.org>  Thu, 01 May 2025 01:19:02 +0200

u-boot (2021.01+dfsg-5) unstable; urgency=medium

  * debian/patches: Fix boot failure caused by efi loader switching to
    non-secure mode too early. Thanks to Bastian Germann and Heinrich
    Schuchardt. (Closes: #988217)

 -- Vagrant Cascadian <vagrant@debian.org>  Sat, 22 May 2021 21:32:45 -0700

u-boot (2021.01+dfsg-4) unstable; urgency=medium

  [ Arnaud Ferraris ]
  * Add support for the pinetab platform (Closes: #982982)
  * u-boot-install-sunxi: fix device tree model for PinePhone 1.1
    (Closes: #984704)

  [ Vagrant Cascadian ]
  * debian/patches: Update PineTab patch use default bootdelay.
  * debian/patches: Add Forwarded link to PineTab patch.
  * debian/rules: Ensure debugging symbols are enabled.
  * debian/rules: Pass argument to remove build path from debug symbols.

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 12 Mar 2021 15:00:43 -0800

u-boot (2021.01+dfsg-3) unstable; urgency=medium

  [ Domenico Andreoli ]
  * u-boot-install-sunxi: Add support for some armhf

  [ Vagrant Cascadian ]
  * debian/watch: Fix missing "/".

  [ Andreas B. Mundt ]
  * Update u-boot-install-sunxi: Add Olimex A20-OLinuXino-LIME2-eMMC

  [ harry88@gmx.ph ]
  * u-boot-install-sunxi: Avoid overriding files in current directory
    (Closes: #982278)

  [ Nicolas Boulenguez ]
  * Enable version 1.1 of the pinephone (Closes: #982981)

  [ Vagrant Cascadian ]
  * u-boot-install-sunxi: Make installing .itb files optional.
  * u-boot-install-sunxi: Add support for armhf targets: Banana Pi
    BPI-M2-Ultra Banana Pi BPI-M3 Banana Pi M2 Berry Cubietech Cubieboard
    Cubietech Cubieboard2 Cubietech Cubieboard4 Cubietech Cubietruck
    Cubietech Cubietruck Plus FriendlyARM NanoPi NEO Air Lamobo R1 LeMaker
    Banana Pi LeMaker Banana Pro LinkSprite pcDuino LinkSprite pcDuino3
    Olimex A10-OLinuXino-LIME Olimex A10s-Olinuxino Micro Olimex
    A20-Olimex-SOM-EVB Olimex A20-OLinuXino-LIME Olimex A20-Olinuxino
    Micro PineRiver Mini X-Plus Xunlong Orange Pi Plus / Plus 2 Xunlong
    Orange Pi Zero

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 01 Mar 2021 00:00:18 -0800

u-boot (2021.01+dfsg-2) unstable; urgency=medium

  * debian/patches: Disable USE_PREBOOT on rockpro64 and pinebook-pro to
    workaround boot failure triggered by USB initialization.
    (Closes: #973323, #980434)

 -- Vagrant Cascadian <vagrant@debian.org>  Thu, 21 Jan 2021 20:36:56 -0800

u-boot (2021.01+dfsg-1) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Fix pinephone platform name in u-boot-install-sunxi64.
    (Closes: #979484)
  * Insert an empty line in target list for consistency. (Closes: #979485)
  * Simplify installation of a link for tegra on arm64 but not armhf
    (Closes: #979486)
  * Install examples for tools with dh_installexamples instead of
    dh_install. (Closes: #979295)
  * Install docs with dh_installdocs instead of dh_install
    (Closes: #979295)

  [ Vagrant Cascadian ]
  * u-boot-install-sunxi64: Drop unused code handling ATF.

